// app.c

#define UNICODE
#define _UNICODE

#include <windows.h>
#include <stdio.h>
#include <string.h>
#include "gameport.h"
#include "joystick.h"

//-----------------------------------------------------------------
VOID main(IN int argc, IN char *argv[])
{
    HANDLE hGamePort = NULL;
    BOOL ret;
    JOY_DATA data;

    //
    // Get a handle to the game port device.
    //
   
    hGamePort = CreateFile(GAMEPORT_WIN32_NAME, GENERIC_READ | 
                           GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 
                           FILE_ATTRIBUTE_NORMAL, NULL);
 
    if (hGamePort == INVALID_HANDLE_VALUE) {
        printf("Error opening device (%d)\n", GetLastError());
        return;
    }

    //
    // Attempt write to gameport device (joystick will disallow).
    //

    if (!WriteFile(hGamePort, &data, 1, &ret, NULL)) {
        if (GetLastError() == ERROR_ACCESS_DENIED) {
            printf("Write denied, as expected\n");
        }
    }

    //
    // Attempt 1 byte read (joystick will fail request).
    //

    if (!ReadFile(hGamePort, &data, 1, &ret, NULL)) {
        if (GetLastError() == ERROR_INSUFFICIENT_BUFFER) {
            printf("Buffer too small, as expected\n");
        }
    }

    //
    // Read a JOY_DATA button state data.
    //

    if (ReadFile(hGamePort, &data, sizeof(JOY_DATA), &ret, NULL)) {
        printf("Device1-Button1 = %s\n", 
               data.Device1Button1 ? "PRESSED" : "OFF");
        printf("Device1-Button2 = %s\n", 
               data.Device1Button2 ? "PRESSED" : "OFF");
        printf("Device2-Button1 = %s\n", 
               data.Device2Button1 ? "PRESSED" : "OFF");
        printf("Device2-Button2 = %s\n", 
               data.Device2Button2 ? "PRESSED" : "OFF");
    }
 
    CloseHandle(hGamePort);

} // main
